<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
  xmlns:o="urn:schemas-microsoft-com:office:office"
  xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
  xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
  xmlns:v="urn:schemas-microsoft-com:vml"
  xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
  xmlns:w10="urn:schemas-microsoft-com:office:word"
  xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
  xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
  xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
  xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
   xmlns:dfx="http://www.topologi.com/2005/Diff-X"
                xmlns:del="http://www.topologi.com/2005/Diff-X/Delete"
                xmlns:ins="http://www.topologi.com/2005/Diff-X/Insert"
                xmlns:diffx="java:com.topologi.diffx.Extension"
  xmlns:fn="http://www.pageseeder.com/function" xmlns:dec="java:java.net.URLDecoder" exclude-result-prefixes="#all">
  
    <!-- 
    handles xref transformations;
    
    -->
  <!--##xref##-->
  <xsl:template match="xref" mode="content">
    <xsl:choose>
      <xsl:when test="@frag != 'default' and @frag != ''">
        <xsl:variable name="internal-reference" select="concat(@uriid,'-',@frag)" />
        <w:hyperlink w:anchor="{replace($internal-reference,'\W','_')}" w:history="1">
        <w:r>
          <w:rPr>
            <xsl:choose>
              <xsl:when test="$xref-style != ''">
                <w:rStyle w:val="{$xref-style}"/>
              </xsl:when>
              <xsl:otherwise>
                <w:color w:val="0000FF"/>
                <w:u w:val="single"/>
              </xsl:otherwise>
            </xsl:choose>
            
            
          </w:rPr>
          <w:t><xsl:value-of select="." /></w:t>
        </w:r>
      </w:hyperlink>
        
        
      </xsl:when>
      <xsl:when test="@frag = 'default'">
        <xsl:variable name="internal-reference" select="@uriid" />
        <w:hyperlink w:anchor="{replace($internal-reference,'\W','_')}" w:history="1">
        <w:r>
           <w:rPr>
            <xsl:choose>
              <xsl:when test="$xref-style != ''">
                <w:rStyle w:val="{$xref-style}"/>
              </xsl:when>
              <xsl:otherwise>
                <w:color w:val="0000FF"/>
                <w:u w:val="single"/>
              </xsl:otherwise>
            </xsl:choose>
          </w:rPr>
          <w:t><xsl:value-of select="." /></w:t>
        </w:r>
      </w:hyperlink>
      </xsl:when>
      <xsl:when test="@href[contains(.,'#')]">
        <xsl:variable name="internal-reference" select="replace(substring-after(@href,'#'),'\W','_')" />
        <w:hyperlink w:anchor="{$internal-reference}" w:history="1">
        <w:r>
          <w:rPr>
            <xsl:choose>
              <xsl:when test="$xref-style != ''">
                <w:rStyle w:val="{$xref-style}"/>
              </xsl:when>
              <xsl:otherwise>
                <w:color w:val="0000FF"/>
                <w:u w:val="single"/>
              </xsl:otherwise>
            </xsl:choose>
          </w:rPr>
          <w:t><xsl:value-of select="." /></w:t>
        </w:r>
      </w:hyperlink>
      </xsl:when>
      
      <xsl:when test="@href[not(contains(.,'#'))][not(ends-with(.,'.psml'))]">
                <!-- only process internal link-->
        <w:hyperlink w:anchor="{@href}" w:history="1">
          <w:r>
            <w:rPr>
	            <xsl:choose>
	              <xsl:when test="$xref-style != ''">
	                <w:rStyle w:val="{$xref-style}"/>
	              </xsl:when>
	              <xsl:otherwise>
	                <w:color w:val="0000FF"/>
	                <w:u w:val="single"/>
	              </xsl:otherwise>
	            </xsl:choose>
	          </w:rPr>
            <w:t xml:space="preserve"><xsl:value-of select="." /></w:t>
          </w:r>
        </w:hyperlink>
      </xsl:when>
      <xsl:when test="@href[not(contains(.,'#'))]">
                <!-- only process internal link-->
          <xsl:variable name="content">
			      <xsl:choose>
			        <xsl:when test="@title!=''">
			          <xsl:value-of select="@title" />
			        </xsl:when>
			        <xsl:otherwise>
			          <xsl:value-of select="@urititle" />
			        </xsl:otherwise>
			      </xsl:choose>
			    </xsl:variable>
			    <w:r>
			      <w:t>
			        <xsl:value-of select="$content" />
			      </w:t>
			    </w:r>
      </xsl:when>
      <xsl:otherwise>
        <w:bookmarkStart w:id="{count(preceding::dfx:ins) + count(preceding::dfx:del) + count(preceding::fragment) + count(ancestor::fragment) +count(preceding::xref) + count(preceding::document) + count(ancestor::document) + count(preceding::link[@name])}"
          w:name="{concat('_a',string(count(preceding::dfx:ins) + count(preceding::dfx:del) + count(preceding::fragment) + count(ancestor::fragment) +count(preceding::xref) + count(preceding::document) + count(ancestor::document) + count(preceding::link[@name])))}" />
        <w:bookmarkEnd w:id="{count(preceding::dfx:ins) + count(preceding::dfx:del) + count(preceding::fragment) + count(ancestor::fragment) +count(preceding::xref) + count(preceding::document) + count(ancestor::document) + count(preceding::link[@name])}" />
      </xsl:otherwise>
    </xsl:choose>
    
  </xsl:template>
  
  <!-- 
handles blockxref transformations;
checks also for document labels so that styles are applied accordingly through the configuration
 -->  
  <!--##blockXref##-->
  <xsl:template match="blockxref" mode="content">
    <xsl:choose>
      <xsl:when test="document | fragment">
        <xsl:variable name="base" select="concat(fn:string-before-last-delimiter(base-uri(),'/'),'/')"/>
<!--         <xsl:message select="concat($base,@href)"/> -->
        <xsl:variable name="currentDocument" select="document(concat($base,@href))"/>
<!--         <xsl:variable name="labels"> -->
<!--           <xsl:choose> -->
<!--             <xsl:when test="document/documentinfo/uri/labels"> -->
<!--               <xsl:value-of select="document/documentinfo/uri/labels"/> -->
<!--             </xsl:when> -->
<!--             <xsl:otherwise> -->
<!--               <xsl:value-of select="''"/> -->
<!--             </xsl:otherwise> -->
<!--           </xsl:choose> -->
<!--         </xsl:variable> -->
        
        <xsl:apply-templates mode="content">
<!--           <xsl:with-param name="labels" select="$labels" tunnel="yes"/> -->
        </xsl:apply-templates>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="content"
          select="if (@title != '')  then @title else @urititle" />
        <w:p>
          <w:r>
            <w:rPr>
              <w:rStyle w:val="reference" />
            </w:rPr>
            <w:t>
              <xsl:value-of select="$content" />
            </w:t>
          </w:r>
        </w:p>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- 
  link href="some http" 
   will create a hyperlink in the document 
   currently only support external link 
   -->
  <!--##link##-->
  <xsl:template match="link" mode="content">
    <xsl:choose>
      <xsl:when test="@href[contains(.,'#')]">
        <xsl:variable name="internal-reference" select="substring-after(@href,'#')" />
        <w:hyperlink w:anchor="{$internal-reference}" w:history="1">
          <w:r>
            <w:rPr>
            <w:rStyle w:val="Hyperlink"/>
            <w:color w:val="0000FF"/>
            <w:u w:val="single"/>
          </w:rPr>
            <w:t xml:space="preserve"><xsl:value-of select="." /></w:t>
          </w:r>
        </w:hyperlink>
      </xsl:when>
      <xsl:when test="@href[not(contains(.,'#'))]">
                <!-- only process internal link-->
        <w:r>
          <w:fldChar w:fldCharType="begin" />
        </w:r>
        <w:r>
          <w:instrText xml:space="preserve"><xsl:text> HYPERLINK "</xsl:text><xsl:value-of
            select="@href" /><xsl:text>" </xsl:text></w:instrText>
        </w:r>
        <w:r>
          <w:fldChar w:fldCharType="separate" />
        </w:r>
        <w:r>
          <w:rPr>
            <xsl:call-template name="apply-style" />
          </w:rPr>
          <w:t>
            <xsl:value-of select="." />
          </w:t>
        </w:r>
        <w:r>
          <w:fldChar w:fldCharType="end" />
        </w:r>
      </xsl:when>
      <xsl:when test="not(@href) and not(@name)">
        <xsl:apply-templates mode="content"/>
      </xsl:when>
      <xsl:when test="@name">
        <w:bookmarkStart w:id="{count(preceding::dfx:ins) + count(preceding::dfx:del) + count(preceding::fragment) + count(ancestor::fragment) +count(preceding::xref) + count(preceding::document) + count(ancestor::document) + count(preceding::link[@name])}"
          w:name="{@name}" />
        <w:bookmarkEnd w:id="{count(preceding::dfx:ins) + count(preceding::dfx:del) + count(preceding::fragment) + count(ancestor::fragment) +count(preceding::xref) + count(preceding::document) + count(ancestor::document) + count(preceding::link[@name])}" />
      
     </xsl:when>
      <xsl:otherwise>
          <xsl:apply-templates mode="content"/>
      
        </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>