<?xml version="1.0" encoding="utf-8"?>

  <!--
    This stylesheet transform openXML into PS Format
  
    @author Hugo Inacio 
    @copyright Allette Systems Pty Ltd 
  -->

<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006" xmlns:o="urn:schemas-microsoft-com:office:office"
	xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships" xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math" xmlns:v="urn:schemas-microsoft-com:vml"
	xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing" xmlns:w10="urn:schemas-microsoft-com:office:word" xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
	xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml" xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture" xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
	xmlns:rs="http://schemas.openxmlformats.org/package/2006/relationships" xmlns:cp="http://schemas.openxmlformats.org/package/2006/metadata/core-properties" xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:dcterms="http://purl.org/dc/terms/" xmlns:ps="http://www.pageseeder.com/editing/2.0" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.pageseeder.com/function"
	exclude-result-prefixes="#all">

  <!-- 
  Template to split each document as sections according to the definitions in the configuration file
   -->
	<xsl:template match="body" mode="section-split">
		<xsl:choose>
			<xsl:when test="$split-by-sections">
			 <section id="title">
          <fragment id="title">
            <xsl:for-each-group select="*" group-ending-with="w:p[fn:matches-section-split-sectionbreak(.)]">
	            <xsl:for-each-group select="current-group()" group-starting-with="w:p[fn:matches-section-split-outline(.) or fn:matches-section-split-styles(.)]">
	                <xsl:choose>
                    <xsl:when test="position() = 1">
                      <xsl:apply-templates select="current-group()[position() = 1]" mode="content" />
                    </xsl:when>
                    <xsl:otherwise></xsl:otherwise>
                  </xsl:choose>
	            </xsl:for-each-group>
	          </xsl:for-each-group>
          </fragment>
        </section>
			 <section id="body">
					<xsl:for-each-group select="*" group-ending-with="w:p[fn:matches-section-split-sectionbreak(.)]">
						<xsl:for-each-group select="current-group()" group-starting-with="w:p[fn:matches-section-split-outline(.) or fn:matches-section-split-styles(.)]">
								<xsl:choose>
                    <xsl:when test="position() != 1">
                      <fragment id="{position()}">
                        <xsl:if test="fn:fragment-type-for-split-style(current-group()//w:pPr[1]/w:pStyle/@w:val[1]) != ''"> 
                         <xsl:attribute name="type" select="fn:fragment-type-for-split-style(current-group()//w:pPr[1]/w:pStyle/@w:val[1])"/>
                        </xsl:if>
			                  <xsl:apply-templates select="current-group()" mode="content" />
			                </fragment>
                    </xsl:when>
                    <xsl:otherwise>
                      <fragment id="{position()}">  
                      <xsl:if test="fn:fragment-type-for-split-style(current-group()//w:pPr[1]/w:pStyle/@w:val[1]) != ''"> 
                        <xsl:attribute name="type" select="fn:fragment-type-for-split-style(current-group()//w:pPr[1]/w:pStyle/@w:val[1])"/>
                       </xsl:if>  
                      <xsl:apply-templates select="current-group()[position() != 1]" mode="content" />
                      </fragment>
                      </xsl:otherwise>
                  </xsl:choose>
						</xsl:for-each-group>
					</xsl:for-each-group>
					</section>
			</xsl:when>
			<xsl:otherwise>
			 <section id="title">
          <fragment id="title">
            <xsl:apply-templates select="*[1]" mode="content" />
          </fragment>
          </section>
				<section id="1">
					<fragment id="1">
						<xsl:apply-templates select="*[position() != 1]" mode="content" />
					</fragment>
				</section>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>