/**
 * Behaviour of the project files page
 * 
 * @author Christophe Lauret
 * @version 3 September 2010
 */

// Declare all global dependencies for JSLint
/*global PAGESEEDER, $ */

// Defines and invokes an anonymous function to create a closure.
$(document).ready(function() {
  
  $('#uri form').submit(function() {
    var $loading = $('<div class="loading"><span>loading</span></div>');
    $('#search-uri').attr('disabled', 'disabled').addClass('disabled').after($loading);
    $('#publish-form input.submit').attr('disabled', 'disabled').addClass('disabled');
    $("#uri div.search-result").load($(this).attr('action'),
      { uriid : $('#uriid').attr('value') },
      function() {
        var format = $('#script-format').attr('value');
        var owner = $('#script-owner').attr('value');
        var uriFormat = $('#uri div.search-result input[name=style-format]').attr('value');
        if (!uriFormat) {uriFormat = '';}
        var grpOwner = $('#uri div.search-result input[name=style-owner]').attr('value');
        if (!grpOwner) {grpOwner = 'default';}
        var good = true;
        // remove previous warning first
        $("#uri div.search-result div.uri-object div.warning").remove();
        if (format !== uriFormat) {
          if (uriFormat == '') {uriFormat = 'none';}
          $("#uri div.search-result div.uri-object").append("<div class='warning'>Format does not match ("+uriFormat+").</div>");
          good = false;
        }
        if (owner !== grpOwner) {
          $("#uri div.search-result div.uri-object").append("<div class='warning'>Owner does not match ("+grpOwner+").</div>");
          good = false;
        }
        if (good) {
          $('#publish-form input.submit').removeAttr('disabled').removeClass('disabled');
        }
        $('#search-uri').removeAttr('disabled').removeClass('disabled');
        $loading.remove();
      });
      return false;
    });
  
  $('#group form').submit(function() {
    $('#search-uri').attr('disabled', 'disabled').addClass('disabled');
    $('#publish-form input.submit').attr('disabled', 'disabled');
    var data = {
        groupid : $('#groupid').attr('value')
    };
    $("#group div.search-result").load($(this).attr('action'), data, function() {
      var owner = $('#script-owner').attr('value');
      var grpOwner = $('#group div.search-result input[name=style-owner]').attr('value');
      if (!grpOwner) {grpOwner = 'default';}
      // remove previous warning first
      $("#group div.search-result div.uri-object div.warning").remove();
      if (owner !== grpOwner && owner !== 'default') {
        $("#group div.search-result div.group-object").append("<div class='warning'>Owner does not match ("+grpOwner+").</div>");
      } else {
        $('#publish-form input.submit').removeAttr('disabled').removeClass('disabled');
      }
      $('#search-uri').removeAttr('disabled').removeClass('disabled');
    });
    return false;
  });

  $('#publish-form input.submit').click(function() {
    $('#publish-form input.submit').attr('disabled', 'disabled').addClass('disabled');
    var data = {
        type            : 'ant',
        script          : $('#script').attr('value'),
        'style-format'  : $('#script-format').attr('value'),
        'style-owner'   : $('#script-owner').attr('value')
    };
    $('div.script input[type=radio]:checked, '+
      'div.script input[type=checkbox]:checked, '+
      'div.script input[type=text], '+
      'div.script input[type=hidden], '+
      '#uri:visible input, '+
      '#group:visible input').each(function() {
      data[$(this).attr('name')] = $(this).attr('value');
    });
    $('div.script input[type=checkbox]').each(function() {
      data[$(this).attr('name')] = $(this).is(':checked');
    });
    $('div.script select').each(function() {
      data[$(this).attr('name')] = $(this).find('option:selected').attr('value');
    });
    $("#console").load($('#publish-form').attr('action'), data, function() {
      var $refresh = $('#console form.refresh');
      var $status = $('#console span.status');
      var $messages = $('#console div.messages');
      var $lastmessage = $('#last-message');
      var refresh = function() {
        $.get($refresh.attr('action'),
          { processid  : $refresh.find('input[name=processid]').attr('value') },
          function(data) {
            var newstatus = $(data).find('span.status').text();
            $status.text(newstatus);
            $status.parent().attr('class', 'status-container ' + newstatus);
            $lastmessage.before($(data).find('div.message'));
            $messages.animate({scrollTop: $lastmessage.offset().top});
            $(data).find('form.refresh').delay(1000).queue(refresh);
            if ($(data).find('form.refresh').size() == 0) {
              $('#console div.loading').remove();
              $('#publish-form input.submit').removeAttr('disabled').removeClass('disabled');;
            }
          });
        };
      $refresh.delay(1000).queue(refresh);
      if ($refresh.size() == 0) {
        $('#publish-form input.submit').removeAttr('disabled').removeClass('disabled');;
      }
    });
    return false;
  });
  /* Choices */
  $('#uri-choice-id').click(function() {
    $(this).nextAll('form').removeClass('hidden');
    $('#uri-choice-browse').nextAll('div.ps-bcb').addClass('hidden');
  });
  $('#uri-choice-browse').click(function() {
    $(this).nextAll('div.ps-bcb').removeClass('hidden');
    $('#uri-choice-id').nextAll('form').addClass('hidden');
  });
  $('#group-choice-id').click(function() {
    $(this).nextAll('form').removeClass('hidden');
    $('#group-choice-browse').nextAll('div.ps-bcb').addClass('hidden');
  });
  $('#group-choice-browse').click(function() {
    $(this).nextAll('div.ps-bcb').removeClass('hidden');
    $('#group-choice-id').nextAll('form').addClass('hidden');
  });
  /* Breadcrumb Bar */
  $('div.ps-bcb').psBcb({
    callback: function(id, path, type) {
      // load a uri?
      if ("uri" == type) {
        $('#uriid').attr('value', id);
        $('#uri form').submit();
      } else if ($('#uri').size() > 0) {
        $('#uri div.search-result').empty();
      } else {
        $('#groupid').attr('value', id);
        $('#group form').submit();
      }
    }
  });
});